/* 
Grammar with semantics and type checking.
Lexical Analyser

*/

%{
#include <stdlib.h>
#include <string.h>
#include "expr.h"
#include "expr.tab.h"
int line = 1;
%}

D [0-9]
LETTER [a-zA-Z]
VARIABLE {LETTER}({LETTER}|{D})*
REAL {D}+\.{D}*
%%
"var" {return T_V_DECL;}
"begin" {return T_begin;}
"end" {return T_end;}
"int" {yylval.tokentype = type_integer; return T_type;}
"real" {yylval.tokentype = type_real; return T_type;}
"+" {return '+';}
"*" {return '*';}
"(" {return '(';}
")" {return ')';} 
"," {return ',';}
":" {return ':';}
";" {return ';';}
{D}+ {yylval.i_val = atoi(yytext);  return T_num;}
{REAL} {yylval.f_val = atof(yytext); return T_real;}
{VARIABLE} {yylval.id = strdup(yytext); return T_id;}
\n  {line++;}
[ \t] { /* nothing */ }
. { 
	printf("Lexical Analysis: Unexpected String! :: %s. in line %d. \n",yytext,line); }
	
%%
